Index: /trunk/src/bp-members/bp-members-template.php
===================================================================
--- /trunk/src/bp-members/bp-members-template.php	(revision 9470)
+++ /trunk/src/bp-members/bp-members-template.php	(revision 9471)
@@ -1298,5 +1298,5 @@
  */
 function bp_get_loggedin_user_nav() {
-	global $bp;
+	$bp = buddypress();
 
 	// Loop through each navigation item
@@ -1340,5 +1340,5 @@
  */
 function bp_get_displayed_user_nav() {
-	global $bp;
+	$bp = buddypress();
 
 	foreach ( (array) $bp->bp_nav as $user_nav_item ) {
@@ -1484,5 +1484,5 @@
 	 */
 	function bp_get_displayed_user_email() {
-		global $bp;
+		$bp = buddypress();
 
 		// If displayed user exists, return email address
@@ -1646,5 +1646,5 @@
  */
 function bp_displayed_user_domain() {
-	global $bp;
+	$bp = buddypress();
 
 	/**
@@ -1664,5 +1664,5 @@
  */
 function bp_loggedin_user_domain() {
-	global $bp;
+	$bp = buddypress();
 
 	/**
@@ -1688,5 +1688,5 @@
 	 */
 	function bp_get_displayed_user_fullname() {
-		global $bp;
+		$bp = buddypress();
 
 		/**
@@ -1718,5 +1718,5 @@
 	 */
 	function bp_get_loggedin_user_fullname() {
-		global $bp;
+		$bp = buddypress();
 
 		/**
@@ -1742,5 +1742,5 @@
 	 */
 	function bp_get_displayed_user_username() {
-		global $bp;
+		$bp = buddypress();
 
 		if ( bp_displayed_user_id() ) {
@@ -1772,5 +1772,5 @@
 	 */
 	function bp_get_loggedin_user_username() {
-		global $bp;
+		$bp = buddypress();
 
 		if ( bp_loggedin_user_id() ) {
@@ -2096,5 +2096,5 @@
 	 */
 	function bp_get_signup_avatar_dir_value() {
-		global $bp;
+		$bp = buddypress();
 
 		// Check if signup_avatar_dir is passed
@@ -2132,7 +2132,5 @@
 	 */
 	function bp_get_current_signup_step() {
-		global $bp;
-
-		return $bp->signup->step;
+		return buddypress()->signup->step;
 	}
 
@@ -2303,9 +2301,10 @@
 	 */
 	function bp_get_members_component_link( $component, $action = '', $query_args = '', $nonce = false ) {
-		global $bp;
 
 		// Must be displayed user
 		if ( !bp_displayed_user_id() )
 			return;
+
+		$bp = buddypress();
 
 		// Append $action to $url if there is no $type
Index: /trunk/src/bp-messages/bp-messages-classes.php
===================================================================
--- /trunk/src/bp-messages/bp-messages-classes.php	(revision 9470)
+++ /trunk/src/bp-messages/bp-messages-classes.php	(revision 9471)
@@ -135,5 +135,5 @@
 	 */
 	public function populate( $thread_id = 0, $order = 'ASC', $args = array() ) {
-		global $wpdb, $bp;
+		global $wpdb;
 
 		if( 'ASC' != $order && 'DESC' != $order ) {
@@ -149,4 +149,6 @@
 		$this->thread_id      = $thread_id;
 
+		$bp = buddypress();
+
 		if ( !$this->messages = $wpdb->get_results( $wpdb->prepare( "SELECT * FROM {$bp->messages->table_name_messages} WHERE thread_id = %d ORDER BY date_sent " . $order, $this->thread_id ) ) ) {
 			return false;
@@ -210,5 +212,7 @@
 	 */
 	public function get_recipients() {
-		global $wpdb, $bp;
+		global $wpdb;
+
+		$bp = buddypress();
 
 		$recipients = array();
@@ -244,5 +248,5 @@
 	 */
 	public static function delete( $thread_id ) {
-		global $wpdb, $bp;
+		global $wpdb;
 
 		/**
@@ -254,4 +258,6 @@
 		 */
 		do_action( 'bp_messages_thread_before_mark_delete', $thread_id );
+
+		$bp = buddypress();
 
 		// Mark messages as deleted
@@ -335,5 +341,5 @@
 	 */
 	public static function get_current_threads_for_user( $args = array() ) {
-		global $wpdb, $bp;
+		global $wpdb;
 
 		// Backward compatibility with old method of passing arguments
@@ -405,4 +411,6 @@
 		}
 
+		$bp = buddypress();
+
 		// set up SQL array
 		$sql = array();
@@ -491,6 +499,7 @@
 	 */
 	public static function mark_as_read( $thread_id ) {
-		global $wpdb, $bp;
-
+		global $wpdb;
+
+		$bp  = buddypress();
 		$sql = $wpdb->prepare( "UPDATE {$bp->messages->table_name_recipients} SET unread_count = 0 WHERE user_id = %d AND thread_id = %d", bp_loggedin_user_id(), $thread_id );
 		$wpdb->query($sql);
@@ -507,6 +516,7 @@
 	 */
 	public static function mark_as_unread( $thread_id ) {
-		global $wpdb, $bp;
-
+		global $wpdb;
+
+		$bp  = buddypress();
 		$sql = $wpdb->prepare( "UPDATE {$bp->messages->table_name_recipients} SET unread_count = 1 WHERE user_id = %d AND thread_id = %d", bp_loggedin_user_id(), $thread_id );
 		$wpdb->query($sql);
@@ -528,5 +538,5 @@
 	 */
 	public static function get_total_threads_for_user( $user_id, $box = 'inbox', $type = 'all' ) {
-		global $wpdb, $bp;
+		global $wpdb;
 
 		$exclude_sender = '';
@@ -539,4 +549,6 @@
 			$type_sql = " AND unread_count = 0 ";
 
+		$bp = buddypress();
+
 		return (int) $wpdb->get_var( $wpdb->prepare( "SELECT COUNT(thread_id) FROM {$bp->messages->table_name_recipients} WHERE user_id = %d AND is_deleted = 0{$exclude_sender} {$type_sql}", $user_id ) );
 	}
@@ -551,5 +563,7 @@
 	 */
 	public static function user_is_sender( $thread_id ) {
-		global $wpdb, $bp;
+		global $wpdb;
+
+		$bp = buddypress();
 
 		$sender_ids = $wpdb->get_col( $wpdb->prepare( "SELECT sender_id FROM {$bp->messages->table_name_messages} WHERE thread_id = %d", $thread_id ) );
@@ -571,5 +585,7 @@
 	 */
 	public static function get_last_sender( $thread_id ) {
-		global $wpdb, $bp;
+		global $wpdb;
+
+		$bp = buddypress();
 
 		if ( ! $sender_id = $wpdb->get_var( $wpdb->prepare( "SELECT sender_id FROM {$bp->messages->table_name_messages} WHERE thread_id = %d GROUP BY sender_id ORDER BY date_sent LIMIT 1", $thread_id ) ) ) {
@@ -589,5 +605,5 @@
 	 */
 	public static function get_inbox_count( $user_id = 0 ) {
-		global $wpdb, $bp;
+		global $wpdb;
 
 		if ( empty( $user_id ) ) {
@@ -598,4 +614,6 @@
 
 		if ( false === $unread_count ) {
+			$bp = buddypress();
+
 			$unread_count = (int) $wpdb->get_var( $wpdb->prepare( "SELECT SUM(unread_count) FROM {$bp->messages->table_name_recipients} WHERE user_id = %d AND is_deleted = 0 AND sender_only = 0", $user_id ) );
 
@@ -624,8 +642,10 @@
 	 */
 	public static function check_access( $thread_id, $user_id = 0 ) {
-		global $wpdb, $bp;
+		global $wpdb;
 
 		if ( empty( $user_id ) )
 			$user_id = bp_loggedin_user_id();
+
+		$bp = buddypress();
 
 		return $wpdb->get_var( $wpdb->prepare( "SELECT id FROM {$bp->messages->table_name_recipients} WHERE thread_id = %d AND is_deleted = 0 AND user_id = %d", $thread_id, $user_id ) );
@@ -694,5 +714,5 @@
 	 */
 	public static function update_tables() {
-		global $wpdb, $bp;
+		global $wpdb;
 
 		$bp_prefix = bp_core_get_table_prefix();
@@ -704,4 +724,6 @@
 			return true;
 		}
+
+		$bp = buddypress();
 
 		foreach( (array) $threads as $thread ) {
@@ -798,5 +820,7 @@
 	 */
 	public function populate( $id ) {
-		global $wpdb, $bp;
+		global $wpdb;
+
+		$bp = buddypress();
 
 		if ( $message = $wpdb->get_row( $wpdb->prepare( "SELECT * FROM {$bp->messages->table_name_messages} WHERE id = %d", $id ) ) ) {
@@ -817,5 +841,7 @@
 	 */
 	public function send() {
-		global $wpdb, $bp;
+		global $wpdb;
+
+		$bp = buddypress();
 
 		$this->sender_id = apply_filters( 'messages_message_sender_id_before_save', $this->sender_id, $this->id );
@@ -891,5 +917,8 @@
 	 */
 	public function get_recipients() {
-		global $bp, $wpdb;
+		global $wpdb;
+
+		$bp = buddypress();
+
 		return $wpdb->get_results( $wpdb->prepare( "SELECT user_id FROM {$bp->messages->table_name_recipients} WHERE thread_id = %d", $this->thread_id ) );
 	}
@@ -925,5 +954,8 @@
 	 */
 	public static function get_last_sent_for_user( $thread_id ) {
-		global $wpdb, $bp;
+		global $wpdb;
+
+		$bp = buddypress();
+
 		return $wpdb->get_var( $wpdb->prepare( "SELECT id FROM {$bp->messages->table_name_messages} WHERE sender_id = %d AND thread_id = %d ORDER BY date_sent DESC LIMIT 1", bp_loggedin_user_id(), $thread_id ) );
 	}
@@ -938,5 +970,8 @@
 	 */
 	public static function is_user_sender( $user_id, $message_id ) {
-		global $wpdb, $bp;
+		global $wpdb;
+
+		$bp = buddypress();
+
 		return $wpdb->get_var( $wpdb->prepare( "SELECT id FROM {$bp->messages->table_name_messages} WHERE sender_id = %d AND id = %d", $user_id, $message_id ) );
 	}
@@ -949,5 +984,8 @@
 	 */
 	public static function get_message_sender( $message_id ) {
-		global $wpdb, $bp;
+		global $wpdb;
+
+		$bp = buddypress();
+
 		return $wpdb->get_var( $wpdb->prepare( "SELECT sender_id FROM {$bp->messages->table_name_messages} WHERE id = %d", $message_id ) );
 	}
@@ -1018,5 +1056,7 @@
 	 */
 	public function populate() {
-		global $wpdb, $bp;
+		global $wpdb;
+
+		$bp = buddypress();
 
 		$notice = $wpdb->get_row( $wpdb->prepare( "SELECT * FROM {$bp->messages->table_name_notices} WHERE id = %d", $this->id ) );
@@ -1038,5 +1078,7 @@
 	 */
 	public function save() {
-		global $wpdb, $bp;
+		global $wpdb;
+
+		$bp = buddypress();
 
 		$this->subject = apply_filters( 'messages_notice_subject_before_save', $this->subject, $this->id );
@@ -1117,5 +1159,5 @@
 	 */
 	public function delete() {
-		global $wpdb, $bp;
+		global $wpdb;
 
 		/**
@@ -1128,4 +1170,5 @@
 		do_action( 'messages_notice_before_delete', $this );
 
+		$bp  = buddypress();
 		$sql = $wpdb->prepare( "DELETE FROM {$bp->messages->table_name_notices} WHERE id = %d", $this->id );
 
@@ -1154,5 +1197,5 @@
 	 */
 	public static function get_notices( $args = array() ) {
-		global $wpdb, $bp;
+		global $wpdb;
 
 		$r = wp_parse_args( $args, array(
@@ -1166,4 +1209,6 @@
 		}
 
+		$bp = buddypress();
+
 		$notices = $wpdb->get_results( "SELECT * FROM {$bp->messages->table_name_notices} ORDER BY date_sent DESC {$limit_sql}" );
 
@@ -1179,7 +1224,9 @@
 	 */
 	public static function get_total_notice_count() {
-		global $wpdb, $bp;
-
-		$notice_count = $wpdb->get_var( "SELECT COUNT(id) FROM " . $bp->messages->table_name_notices );
+		global $wpdb;
+
+		$bp = buddypress();
+
+		$notice_count = $wpdb->get_var( "SELECT COUNT(id) FROM {$bp->messages->table_name_notices}" );
 
 		return $notice_count;
@@ -1197,5 +1244,7 @@
 
 		if ( false === $notice ) {
-			global $wpdb, $bp;
+			global $wpdb;
+
+			$bp = buddypress();
 
 			$notice_id = $wpdb->get_var( "SELECT id FROM {$bp->messages->table_name_notices} WHERE is_active = 1" );
Index: /trunk/src/bp-xprofile/bp-xprofile-admin.php
===================================================================
--- /trunk/src/bp-xprofile/bp-xprofile-admin.php	(revision 9470)
+++ /trunk/src/bp-xprofile/bp-xprofile-admin.php	(revision 9471)
@@ -262,5 +262,7 @@
  */
 function xprofile_admin_manage_field( $group_id, $field_id = null ) {
-	global $bp, $wpdb, $message, $groups;
+	global $wpdb, $message, $groups;
+
+	$bp = buddypress();
 
 	$field           = new BP_XProfile_Field( $field_id );
Index: /trunk/src/bp-xprofile/bp-xprofile-classes.php
===================================================================
--- /trunk/src/bp-xprofile/bp-xprofile-classes.php	(revision 9470)
+++ /trunk/src/bp-xprofile/bp-xprofile-classes.php	(revision 9471)
@@ -25,9 +25,10 @@
 
 	public function populate( $id ) {
-		global $wpdb, $bp;
+		global $wpdb;
 
 		$group = wp_cache_get( 'xprofile_group_' . $this->id, 'bp' );
 
 		if ( false === $group ) {
+			$bp = buddypress();
 			$group = $wpdb->get_row( $wpdb->prepare( "SELECT * FROM {$bp->profile->table_name_groups} WHERE id = %d", $id ) );
 		}
@@ -45,5 +46,5 @@
 
 	public function save() {
-		global $wpdb, $bp;
+		global $wpdb;
 
 		$this->name        = apply_filters( 'xprofile_group_name_before_save',        $this->name,        $this->id );
@@ -60,4 +61,6 @@
 		 */
 		do_action_ref_array( 'xprofile_group_before_save', array( &$this ) );
+
+		$bp = buddypress();
 
 		if ( $this->id )
@@ -86,5 +89,5 @@
 
 	public function delete() {
-		global $wpdb, $bp;
+		global $wpdb;
 
 		if ( empty( $this->can_delete ) )
@@ -99,4 +102,6 @@
 		 */
 		do_action_ref_array( 'xprofile_group_before_delete', array( &$this ) );
+
+		$bp = buddypress();
 
 		// Delete field group
@@ -163,5 +168,5 @@
 	 */
 	public static function get( $args = array() ) {
-		global $wpdb, $bp;
+		global $wpdb;
 
 		$defaults = array(
@@ -197,4 +202,6 @@
 		}
 
+		$bp = buddypress();
+
 		if ( ! empty( $hide_empty_groups ) ) {
 			$group_ids = $wpdb->get_col( "SELECT DISTINCT g.id FROM {$bp->profile->table_name_groups} g INNER JOIN {$bp->profile->table_name_fields} f ON g.id = f.group_id {$where_sql} ORDER BY g.group_order ASC" );
@@ -416,5 +423,5 @@
 
 	public static function update_position( $field_group_id, $position ) {
-		global $wpdb, $bp;
+		global $wpdb;
 
 		if ( !is_numeric( $position ) ) {
@@ -424,4 +431,6 @@
 		// purge profile field group cache
 		wp_cache_delete( 'xprofile_groups_inc_empty', 'bp' );
+
+		$bp = buddypress();
 
 		return $wpdb->query( $wpdb->prepare( "UPDATE {$bp->profile->table_name_groups} SET group_order = %d WHERE id = %d", $position, $field_group_id ) );
@@ -481,9 +490,11 @@
 	 */
 	public static function fetch_default_visibility_levels() {
-		global $wpdb, $bp;
+		global $wpdb;
 
 		$default_visibility_levels = wp_cache_get( 'xprofile_default_visibility_levels', 'bp' );
 
 		if ( false === $default_visibility_levels ) {
+			$bp = buddypress();
+
 			$levels = $wpdb->get_results( "SELECT object_id, meta_key, meta_value FROM {$bp->profile->table_name_meta} WHERE object_type = 'field' AND ( meta_key = 'default_visibility' OR meta_key = 'allow_custom_visibility' )" );
 
@@ -658,5 +669,5 @@
 
 	public function populate( $id, $user_id, $get_data ) {
-		global $wpdb, $userdata, $bp;
+		global $wpdb, $userdata;
 
 		if ( empty( $user_id ) ) {
@@ -664,4 +675,5 @@
 		}
 
+		$bp  = buddypress();
 		$sql = $wpdb->prepare( "SELECT * FROM {$bp->profile->table_name_fields} WHERE id = %d", $id );
 
@@ -699,5 +711,5 @@
 
 	public function delete( $delete_data = false ) {
-		global $wpdb, $bp;
+		global $wpdb;
 
 		// Prevent deletion if no ID is present
@@ -707,4 +719,6 @@
 			return false;
 
+		$bp = buddypress();
+
 		if ( !$wpdb->query( $wpdb->prepare( "DELETE FROM {$bp->profile->table_name_fields} WHERE id = %d OR parent_id = %d", $this->id, $this->id ) ) )
 			return false;
@@ -718,5 +732,7 @@
 
 	public function save() {
-		global $wpdb, $bp;
+		global $wpdb;
+
+		$bp = buddypress();
 
 		$this->group_id    = apply_filters( 'xprofile_field_group_id_before_save',    $this->group_id,    $this->id );
@@ -857,5 +873,5 @@
 
 	public function get_children( $for_editing = false ) {
-		global $wpdb, $bp;
+		global $wpdb;
 
 		// This is done here so we don't have problems with sql injection
@@ -875,4 +891,5 @@
 		}
 
+		$bp  = buddypress();
 		$sql = $wpdb->prepare( "SELECT * FROM {$bp->profile->table_name_fields} WHERE parent_id = %d AND group_id = %d $sort_sql", $parent_id, $this->group_id );
 
@@ -891,6 +908,7 @@
 
 	public function delete_children() {
-		global $wpdb, $bp;
-
+		global $wpdb;
+
+		$bp  = buddypress();
 		$sql = $wpdb->prepare( "DELETE FROM {$bp->profile->table_name_fields} WHERE parent_id = %d", $this->id );
 
@@ -901,7 +919,8 @@
 
 	public static function get_type( $field_id ) {
-		global $wpdb, $bp;
+		global $wpdb;
 
 		if ( !empty( $field_id ) ) {
+			$bp  = buddypress();
 			$sql = $wpdb->prepare( "SELECT type FROM {$bp->profile->table_name_fields} WHERE id = %d", $field_id );
 
@@ -917,7 +936,8 @@
 
 	public static function delete_for_group( $group_id ) {
-		global $wpdb, $bp;
+		global $wpdb;
 
 		if ( !empty( $group_id ) ) {
+			$bp  = buddypress();
 			$sql = $wpdb->prepare( "DELETE FROM {$bp->profile->table_name_fields} WHERE group_id = %d", $group_id );
 
@@ -933,5 +953,7 @@
 
 	public static function get_id_from_name( $field_name ) {
-		global $wpdb, $bp;
+		global $wpdb;
+
+		$bp = buddypress();
 
 		if ( empty( $bp->profile->table_name_fields ) || !isset( $field_name ) )
@@ -942,8 +964,10 @@
 
 	public static function update_position( $field_id, $position, $field_group_id ) {
-		global $wpdb, $bp;
+		global $wpdb;
 
 		if ( !is_numeric( $position ) || !is_numeric( $field_group_id ) )
 			return false;
+
+		$bp = buddypress();
 
 		// Update $field_id with new $position and $field_group_id
@@ -1221,5 +1245,5 @@
 
 	public function populate( $field_id, $user_id )  {
-		global $wpdb, $bp;
+		global $wpdb;
 
 		$cache_key   = "{$user_id}:{$field_id}";
@@ -1227,4 +1251,6 @@
 
 		if ( false === $profiledata ) {
+			$bp = buddypress();
+
 			$sql         = $wpdb->prepare( "SELECT * FROM {$bp->profile->table_name_data} WHERE field_id = %d AND user_id = %d", $field_id, $user_id );
 			$profiledata = $wpdb->get_row( $sql );
@@ -1257,5 +1283,5 @@
 	 */
 	public function exists() {
-		global $wpdb, $bp;
+		global $wpdb;
 
 		// Check cache first
@@ -1266,4 +1292,5 @@
 			$retval = true;
 		} else {
+			$bp = buddypress();
 			$retval = $wpdb->get_row( $wpdb->prepare( "SELECT id FROM {$bp->profile->table_name_data} WHERE user_id = %d AND field_id = %d", $this->user_id, $this->field_id ) );
 		}
@@ -1284,9 +1311,10 @@
 	 *
 	 * @global object $wpdb
-	 * @global array $bp
 	 * @return bool
 	 */
 	public function is_valid_field() {
-		global $wpdb, $bp;
+		global $wpdb;
+
+		$bp = buddypress();
 
 		$retval = $wpdb->get_row( $wpdb->prepare( "SELECT id FROM {$bp->profile->table_name_fields} WHERE id = %d", $this->field_id ) );
@@ -1304,5 +1332,7 @@
 
 	public function save() {
-		global $wpdb, $bp;
+		global $wpdb;
+
+		$bp = buddypress();
 
 		$this->user_id      = apply_filters( 'xprofile_data_user_id_before_save',      $this->user_id,         $this->id );
@@ -1509,9 +1539,10 @@
 	 */
 	public static function get_fielddataid_byid( $field_id, $user_id ) {
-		global $wpdb, $bp;
+		global $wpdb;
 
 		if ( empty( $field_id ) || empty( $user_id ) ) {
 			$fielddata_id = 0;
 		} else {
+			$bp = buddypress();
 
 			// Check cache first
@@ -1539,5 +1570,5 @@
 	 */
 	public static function get_value_byid( $field_id, $user_ids = null ) {
-		global $wpdb, $bp;
+		global $wpdb;
 
 		if ( empty( $user_ids ) ) {
@@ -1562,4 +1593,5 @@
 		// Prime caches
 		if ( ! empty( $uncached_ids ) ) {
+			$bp = buddypress();
 			$uncached_ids_sql = implode( ',', $uncached_ids );
 			$queried_data = $wpdb->get_results( $wpdb->prepare( "SELECT id, user_id, field_id, value, last_updated FROM {$bp->profile->table_name_data} WHERE field_id = %d AND user_id IN ({$uncached_ids_sql})", $field_id ) );
@@ -1610,8 +1642,10 @@
 
 	public static function get_value_byfieldname( $fields, $user_id = null ) {
-		global $bp, $wpdb;
+		global $wpdb;
 
 		if ( empty( $fields ) )
 			return false;
+
+		$bp = buddypress();
 
 		if ( empty( $user_id ) )
@@ -1659,5 +1693,7 @@
 
 	public static function delete_for_field( $field_id ) {
-		global $wpdb, $bp;
+		global $wpdb;
+
+		$bp = buddypress();
 
 		if ( !$wpdb->query( $wpdb->prepare( "DELETE FROM {$bp->profile->table_name_data} WHERE field_id = %d", $field_id ) ) )
@@ -1668,5 +1704,7 @@
 
 	public static function get_last_updated( $user_id ) {
-		global $wpdb, $bp;
+		global $wpdb;
+
+		$bp = buddypress();
 
 		$last_updated = $wpdb->get_var( $wpdb->prepare( "SELECT last_updated FROM {$bp->profile->table_name_data} WHERE user_id = %d ORDER BY last_updated LIMIT 1", $user_id ) );
@@ -1676,5 +1714,7 @@
 
 	public static function delete_data_for_user( $user_id ) {
-		global $wpdb, $bp;
+		global $wpdb;
+
+		$bp = buddypress();
 
 		return $wpdb->query( $wpdb->prepare( "DELETE FROM {$bp->profile->table_name_data} WHERE user_id = %d", $user_id ) );
@@ -1682,7 +1722,9 @@
 
 	public static function get_random( $user_id, $exclude_fullname ) {
-		global $wpdb, $bp;
+		global $wpdb;
 
 		$exclude_sql = ! empty( $exclude_fullname ) ? ' AND pf.id != 1' : '';
+
+		$bp = buddypress();
 
 		return $wpdb->get_results( $wpdb->prepare( "SELECT pf.type, pf.name, pd.value FROM {$bp->profile->table_name_data} pd INNER JOIN {$bp->profile->table_name_fields} pf ON pd.field_id = pf.id AND pd.user_id = %d {$exclude_sql} ORDER BY RAND() LIMIT 1", $user_id ) );
Index: /trunk/src/bp-xprofile/bp-xprofile-functions.php
===================================================================
--- /trunk/src/bp-xprofile/bp-xprofile-functions.php	(revision 9470)
+++ /trunk/src/bp-xprofile/bp-xprofile-functions.php	(revision 9471)
@@ -218,5 +218,4 @@
  */
 function xprofile_insert_field( $args = '' ) {
-	global $bp;
 
 	$r = wp_parse_args( $args, array(
@@ -240,5 +239,5 @@
 
 	// Check this is a valid field type
-	if ( ! in_array( $r['type'], (array) $bp->profile->field_types ) ) {
+	if ( ! in_array( $r['type'], (array) buddypress()->profile->field_types ) ) {
 		return false;
 	}
@@ -1022,5 +1021,4 @@
  */
 function bp_xprofile_get_visibility_levels() {
-	global $bp;
 
 	/**
@@ -1031,5 +1029,5 @@
 	 * @param array $visibility_levels Array of visibility levels.
 	 */
-	return apply_filters( 'bp_xprofile_get_visibility_levels', $bp->profile->visibility_levels );
+	return apply_filters( 'bp_xprofile_get_visibility_levels', buddypress()->profile->visibility_levels );
 }
 
Index: /trunk/src/bp-xprofile/bp-xprofile-template.php
===================================================================
--- /trunk/src/bp-xprofile/bp-xprofile-template.php	(revision 9470)
+++ /trunk/src/bp-xprofile/bp-xprofile-template.php	(revision 9471)
@@ -370,5 +370,7 @@
 }
 	function bp_get_the_profile_group_edit_form_action() {
-		global $bp, $group;
+		global $group;
+
+		$bp = buddypress();
 
 		/**
@@ -845,6 +847,7 @@
  */
 function bp_profile_group_tabs() {
-	global $bp, $group_name;
-
+	global $group_name;
+
+	$bp     = buddypress();
 	$groups = bp_profile_get_field_groups();
 
@@ -967,5 +970,5 @@
 }
 	function bp_get_avatar_delete_link() {
-		global $bp;
+		$bp = buddypress();
 
 		/**
@@ -980,5 +983,5 @@
 
 function bp_edit_profile_button() {
-	global $bp;
+	$bp = buddypress();
 
 	bp_button( array (
Index: /trunk/tests/phpunit/includes/testcase.php
===================================================================
--- /trunk/tests/phpunit/includes/testcase.php	(revision 9470)
+++ /trunk/tests/phpunit/includes/testcase.php	(revision 9471)
@@ -328,9 +328,8 @@
 	 * user during tests. BP caches the current user differently, so we
 	 * have to do a bit more work to change it
-	 *
-	 * @global BuddyPres $bp
 	 */
 	public static function set_current_user( $user_id ) {
-		global $bp;
+		$bp = buddypress();
+
 		$bp->loggedin_user->id = $user_id;
 		$bp->loggedin_user->fullname       = bp_core_get_user_displayname( $user_id );
Index: /trunk/tests/phpunit/testcases/activity/template.php
===================================================================
--- /trunk/tests/phpunit/testcases/activity/template.php	(revision 9470)
+++ /trunk/tests/phpunit/testcases/activity/template.php	(revision 9471)
@@ -22,5 +22,5 @@
 	 */
 	public function test_user_can_delete() {
-		global $bp;
+		$bp = buddypress();
 
 		$a = $this->factory->activity->create( array(
@@ -134,6 +134,4 @@
 			'action' => 'activity_update',
 		) );
-
-		global $wpdb, $bp;
 
 		$ids = wp_list_pluck( $activities_template->activities, 'id' );
Index: /trunk/tests/phpunit/testcases/core/cache.php
===================================================================
--- /trunk/tests/phpunit/testcases/core/cache.php	(revision 9470)
+++ /trunk/tests/phpunit/testcases/core/cache.php	(revision 9471)
@@ -14,5 +14,8 @@
 
 		// Confirm that all activitymeta is deleted
-		global $wpdb, $bp;
+		global $wpdb;
+
+		$bp = buddypress();
+
 		$wpdb->query( $wpdb->prepare( "DELETE FROM {$bp->activity->table_name_meta} WHERE activity_id = %d", $a1 ) );
 
Index: /trunk/tests/phpunit/testcases/groups/functions.php
===================================================================
--- /trunk/tests/phpunit/testcases/groups/functions.php	(revision 9470)
+++ /trunk/tests/phpunit/testcases/groups/functions.php	(revision 9471)
@@ -442,5 +442,7 @@
 
 		// Get rid of any auto-created values
-		global $wpdb, $bp;
+		global $wpdb;
+
+		$bp = buddypress();
 		$wpdb->query( $wpdb->prepare( "DELETE FROM {$bp->groups->table_name_groupmeta} WHERE group_id = %d", $g ) );
 		wp_cache_delete( $g, 'group_meta' );
Index: /trunk/tests/phpunit/testcases/members/functions.php
===================================================================
--- /trunk/tests/phpunit/testcases/members/functions.php	(revision 9470)
+++ /trunk/tests/phpunit/testcases/members/functions.php	(revision 9471)
@@ -172,6 +172,7 @@
 	 */
 	public function test_bp_core_get_user_displayname_xprofile_does_not_exist() {
+		$bp = buddypress();
 		$xprofile_is_active = bp_is_active( 'xprofile' );
-		buddypress()->active_components['xprofile'] = '1';
+		$bp->active_components['xprofile'] = '1';
 
 		$u = $this->factory->user->create( array(
@@ -181,5 +182,5 @@
 		// Delete directly because BP won't let you delete a required
 		// field through the API
-		global $wpdb, $bp;
+		global $wpdb;
 		$wpdb->query( $wpdb->prepare( "DELETE FROM {$bp->profile->table_name_data} WHERE user_id = %d AND field_id = 1", $u ) );
 		wp_cache_delete( 'bp_user_fullname_' . $u, 'bp' );
@@ -191,5 +192,5 @@
 
 		if ( ! $xprofile_is_active ) {
-			unset( buddypress()->active_components['xprofile'] );
+			unset( $bp->active_components['xprofile'] );
 		}
 	}
@@ -233,5 +234,6 @@
 		// Delete directly because BP won't let you delete a required
 		// field through the API
-		global $wpdb, $bp;
+		global $wpdb;
+		$bp = buddypress();
 		$wpdb->query( $wpdb->prepare( "DELETE FROM {$bp->profile->table_name_data} WHERE user_id = %d AND field_id = 1", $u2 ) );
 		wp_cache_delete( 'bp_user_fullname_' . $u2, 'bp' );
@@ -378,5 +380,6 @@
 
 		// Create an existing entry in last_activity to test no dupes
-		global $wpdb, $bp;
+		global $wpdb;
+		$bp = buddypress();
 		$wpdb->query( $wpdb->prepare(
 			"INSERT INTO {$bp->members->table_name_last_activity}
